#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <kpathsea.h>
#include <c-auto.h>

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int len, int arg)
{
    errno = EINVAL;
    return 0;
}

I32
_get_kpathsea_debug(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_kpathsea_debug", G_DISCARD);
    return (I32)0;
}

I32
_set_kpathsea_debug(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_kpathsea_debug", G_DISCARD);
    return (I32)0;
}

I32
_get_kpse_fallback_font(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_kpse_fallback_font", G_DISCARD);
    return (I32)0;
}

I32
_set_kpse_fallback_font(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_kpse_fallback_font", G_DISCARD);
    return (I32)0;
}

I32
_get_kpse_fallback_resolutions(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_kpse_fallback_resolutions", G_DISCARD);
    return (I32)0;
}

I32
_set_kpse_fallback_resolutions(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_kpse_fallback_resolutions", G_DISCARD);
    return (I32)0;
}

I32
_get_kpse_fallback_resolutions_string(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_kpse_fallback_resolutions_string", G_DISCARD);
    return (I32)0;
}

I32
_set_kpse_fallback_resolutions_string(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_kpse_fallback_resolutions_string", G_DISCARD);
    return (I32)0;
}

I32
_get_kpse_program_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_kpse_program_name", G_DISCARD);
    return (I32)0;
}

I32
_set_kpse_program_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_kpse_program_name", G_DISCARD);
    return (I32)0;
}


I32
_get_program_invocation_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_program_invocation_name", G_DISCARD);
    return (I32)0;
}

I32
_set_program_invocation_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_program_invocation_name", G_DISCARD);
    return (I32)0;
}

I32
_get_program_invocation_short_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_get_program_invocation_short_name", G_DISCARD);
    return (I32)0;
}

I32
_set_program_invocation_short_name(IV index, SV *sv) {
    dSP;
    PUSHMARK(SP);
    XPUSHs(sv);
    PUTBACK;
    (void)call_pv("Kpse::_set_program_invocation_short_name", G_DISCARD);
    return (I32)0;
}


MODULE = Kpse		PACKAGE = Kpse		


double
constant(sv,arg)
    PREINIT:
	STRLEN		len;
    INPUT:
	SV *		sv
	char *		s = SvPV(sv, len);
	int		arg
    CODE:
	RETVAL = constant(s,len,arg);
    OUTPUT:
	RETVAL


void
_tievar_kpathsea_debug(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_kpathsea_debug;
	uf.uf_set = &_set_kpathsea_debug;
	uf.uf_index = (IV)&_get_kpathsea_debug;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_kpathsea_debug(THIS)
	unsigned THIS = NO_INIT
    CODE:
	THIS = kpathsea_debug;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_kpathsea_debug(THIS)
	unsigned THIS
    CODE:
	kpathsea_debug = THIS;

void
_tievar_kpse_fallback_font(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_kpse_fallback_font;
	uf.uf_set = &_set_kpse_fallback_font;
	uf.uf_index = (IV)&_get_kpse_fallback_font;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_kpse_fallback_font(THIS)
	const_string THIS = NO_INIT
    CODE:
	THIS = kpse_fallback_font;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_kpse_fallback_font(THIS)
	const_string THIS
    CODE:
	kpse_fallback_font = THIS;

void
_tievar_kpse_fallback_resolutions(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_kpse_fallback_resolutions;
	uf.uf_set = &_set_kpse_fallback_resolutions;
	uf.uf_index = (IV)&_get_kpse_fallback_resolutions;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_kpse_fallback_resolutions(THIS)
	unsigned * THIS = NO_INIT
    CODE:
	THIS = kpse_fallback_resolutions;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_kpse_fallback_resolutions(THIS)
	unsigned * THIS
    CODE:
	kpse_fallback_resolutions = THIS;

void
_tievar_kpse_fallback_resolutions_string(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_kpse_fallback_resolutions_string;
	uf.uf_set = &_set_kpse_fallback_resolutions_string;
	uf.uf_index = (IV)&_get_kpse_fallback_resolutions_string;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_kpse_fallback_resolutions_string(THIS)
	const_string THIS = NO_INIT
    CODE:
	THIS = kpse_fallback_resolutions_string;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_kpse_fallback_resolutions_string(THIS)
	const_string THIS
    CODE:
	kpse_fallback_resolutions_string = THIS;


void
_tievar_kpse_program_name(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_kpse_program_name;
	uf.uf_set = &_set_kpse_program_name;
	uf.uf_index = (IV)&_get_kpse_program_name;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_kpse_program_name(THIS)
	string THIS = NO_INIT
    CODE:
	THIS = kpse_program_name;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_kpse_program_name(THIS)
	string THIS
    CODE:
	kpse_program_name = THIS;


void
_tievar_program_invocation_name(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_program_invocation_name;
	uf.uf_set = &_set_program_invocation_name;
	uf.uf_index = (IV)&_get_program_invocation_name;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_program_invocation_name(THIS)
	string THIS = NO_INIT
    CODE:
	THIS = program_invocation_name;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_program_invocation_name(THIS)
	string THIS
    CODE:
	program_invocation_name = THIS;

void
_tievar_program_invocation_short_name(sv)
	SV* sv
    PREINIT:
	struct ufuncs uf;
    CODE:
	uf.uf_val = &_get_program_invocation_short_name;
	uf.uf_set = &_set_program_invocation_short_name;
	uf.uf_index = (IV)&_get_program_invocation_short_name;
	sv_magic(sv, 0, 'U', (char*)&uf, sizeof(uf));

void
_get_program_invocation_short_name(THIS)
	string THIS = NO_INIT
    CODE:
	THIS = program_invocation_short_name;
    OUTPUT:
	SETMAGIC: DISABLE
	THIS

void
_set_program_invocation_short_name(THIS)
	string THIS
    CODE:
	program_invocation_short_name = THIS;



string
extend_filename(name, suffix)
	const_string	name
	const_string	suffix

string
find_suffix(name)
	const_string	name

boolean
kpse_absolute_p(filename, relative_ok)
	const_string	filename
	boolean	relative_ok

boolean
kpse_bitmap_tolerance(dpi1, dpi2)
	double	dpi1
	double	dpi2

string
kpse_brace_expand(path)
	const_string	path

string
kpse_cnf_get(var)
	const_string	var

void
kpse_db_insert(fname)
	const_string	fname

string
kpse_expand(s)
	const_string	s

string
kpse_expand_default(path, dflt)
	const_string	path
	const_string	dflt

string
kpse_filename_component(path)
	const_string	path

string
kpse_find_file(name, format, must_exist)
	const_string	name
	kpse_file_format_type	format
	boolean	must_exist

string
kpse_find_glyph(font_name, dpi, format, glyph_file)
	const_string	font_name
	unsigned	dpi
	kpse_file_format_type	format
	kpse_glyph_file_type *	glyph_file

AV *
kpse_db_search(name, path_elt, all)
	const_string	name
	const_string	path_elt
	boolean	all
	PREINIT:
	    AV *suffix_av;
		string *ext;
	    str_list_type *list;
	    int size;
	    char * test;
    CODE:
	suffix_av = newAV();
	list = kpse_db_search(name,path_elt,all);
	if(list && STR_LIST_LENGTH(*list) && STR_LIST(*list)){
	  size = STR_LIST_LENGTH(*list);
	  ext = (*list).list;
	  while (ext && *ext && size) {
		av_push(suffix_av,newSVpv(*ext,0)) ;
	    ext++;
	    size--;
      }  
    }	
	RETVAL = suffix_av;
    OUTPUT:
	RETVAL
	

AV *
kpse_fontmap_lookup(key)
	const_string	key
    PROTOTYPE: $
	PREINIT:
	    AV *suffix_av;
		string *ext;
    CODE:
	suffix_av = newAV();
    ext = kpse_fontmap_lookup(key);
	for (ext; ext && *ext; ext++) {
		av_push(suffix_av,newSVpv(*ext,0));
	}
	RETVAL = suffix_av;
    OUTPUT:
	RETVAL

void
kpse_init_db()

void
kpse_init_fallback_resolutions(envvar)
	string	envvar

const_string
kpse_init_format(arg0)
	kpse_file_format_type	arg0

void
kpse_init_prog(prefix, dpi, mode, fallback)
	const_string	prefix
	unsigned	dpi
	const_string	mode
	const_string	fallback

unsigned
kpse_magstep_fix(dpi, bdpi, m_ret)
	unsigned	dpi
	unsigned	bdpi
	int *	m_ret

string
kpse_make_tex(format, base_file)
	kpse_file_format_type	format
	const_string	base_file

void
kpse_maketex_option(fmtname, value)
	const_string	fmtname
	boolean	value

FILE *
kpse_open_file(arg0, arg1)
	const_string	arg0
	kpse_file_format_type	arg1

string
kpse_path_element(path)
	const_string	path

string
kpse_path_expand(path)
	const_string	path

AV *
kpse_all_path_search(path, name)
	const_string	path
	const_string	name
	PREINIT:
	    AV *suffix_av;
		string *ext;
    CODE:
	suffix_av = newAV();
	for (ext = (string *)kpse_all_path_search(path,name); ext && *ext ; ext++) {
		av_push(suffix_av,newSVpv(*ext,0));
	}
	RETVAL = suffix_av;
    OUTPUT:
	RETVAL

string
kpse_path_search(path, name, must_exist)
	const_string	path
	const_string	name
	boolean	must_exist

string
kpse_readable_file(name)
	const_string	name

void
kpse_reset_program_name(progname)
	const_string	progname

void
kpse_set_progname(argv0)
	const_string	argv0

void
kpse_set_program_enabled(fmt, value, level)
	kpse_file_format_type	fmt
	boolean	value
	kpse_src_type	level

void
kpse_set_program_name(argv0, progname)
	const_string	argv0
	const_string	progname

boolean
kpse_tex_hush(what)
	const_string	what

string
kpse_tilde_expand(filename)
	const_string	filename

string
kpse_truncate_filename(name)
	const_string	name

string
kpse_var_expand(src)
	const_string	src

string
kpse_var_value(var)
	const_string	var


string
make_prefix(stem_prefix, name)
	string	stem_prefix
	string	name

string
make_suffix(s, suffix)
	const_string	s
	const_string	suffix

string
remove_suffix(name)
	const_string	name

string
kpse_version()
	CODE:
		RETVAL =  KPSEVERSION;
	OUTPUT:
		RETVAL

unsigned
kpse_total_formats()
	CODE:
		RETVAL =  kpse_last_format;
	OUTPUT:
		RETVAL

kpse_format_info_type *
kpse_format_info(index)
	unsigned index
    PROTOTYPE: $
	CODE:
	 	RETVAL = &kpse_format_info[index];
	OUTPUT:
		RETVAL
	

MODULE = Kpse		PACKAGE = kpse_format_info_type

kpse_format_info_type *
_to_ptr(THIS)
	kpse_format_info_type THIS = NO_INIT
    PROTOTYPE: $
    CODE:
	if (sv_derived_from(ST(0), "kpse_format_info_type")) {
	    STRLEN len;
	    char *s = SvPV((SV*)SvRV(ST(0)), len);
	    if (len != sizeof(THIS))
		croak("Size %d of packed data != expected %d",
			len, sizeof(THIS));
	    RETVAL = (kpse_format_info_type *)s;
	}   
	else
	    croak("THIS is not of type kpse_format_info_type");
    OUTPUT:
	RETVAL

kpse_format_info_type
new(CLASS)
	char *CLASS = NO_INIT
    PROTOTYPE: $
    CODE:
	Zero((void*)&RETVAL, sizeof(RETVAL), char);
    OUTPUT:
	RETVAL

MODULE = Kpse		PACKAGE = kpse_format_info_typePtr

const_string
type(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->type = __value;
	RETVAL = THIS->type;
    OUTPUT:
	RETVAL

const_string
path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->path = __value;
	RETVAL = THIS->path;
    OUTPUT:
	RETVAL

const_string
raw_path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->raw_path = __value;
	RETVAL = THIS->raw_path;
    OUTPUT:
	RETVAL

const_string
path_source(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->path_source = __value;
	RETVAL = THIS->path_source;
    OUTPUT:
	RETVAL

const_string
override_path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->override_path = __value;
	RETVAL = THIS->override_path;
    OUTPUT:
	RETVAL

const_string
client_path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->client_path = __value;
	RETVAL = THIS->client_path;
    OUTPUT:
	RETVAL

const_string
cnf_path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->cnf_path = __value;
	RETVAL = THIS->cnf_path;
    OUTPUT:
	RETVAL

const_string
default_path(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->default_path = __value;
	RETVAL = THIS->default_path;
    OUTPUT:
	RETVAL

AV *
suffix(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string * __value
    PROTOTYPE: $;$
	PREINIT:
	    AV *suffix_av;
		const_string *ext;
    CODE:
	if (items > 1)
	    THIS->suffix = __value;
	suffix_av = newAV();
	for (ext = THIS->suffix; ext && *ext; ext++) {
		av_push(suffix_av,newSVpv(*ext,0));
	}
	RETVAL = suffix_av;
    OUTPUT:
	RETVAL

AV *
alt_suffix(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string * __value
    PROTOTYPE: $;$
	PREINIT:
	    AV *suffix_av;
		const_string *ext;
    CODE:
	if (items > 1)
	    THIS->suffix = __value;
	suffix_av = newAV();
	for (ext = THIS->alt_suffix; ext && *ext; ext++) {
		av_push(suffix_av,newSVpv(*ext,0));
	}
	RETVAL = suffix_av;
    OUTPUT:
	RETVAL

boolean
suffix_search_only(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	boolean __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->suffix_search_only = __value;
	RETVAL = THIS->suffix_search_only;
    OUTPUT:
	RETVAL

const_string
program(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->program = __value;
	RETVAL = THIS->program;
    OUTPUT:
	RETVAL

const_string
program_args(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	const_string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->program_args = __value;
	RETVAL = THIS->program_args;
    OUTPUT:
	RETVAL

boolean
program_enabled_p(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	boolean __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->program_enabled_p = __value;
	RETVAL = THIS->program_enabled_p;
    OUTPUT:
	RETVAL

kpse_src_type
program_enable_level(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	kpse_src_type __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->program_enable_level = __value;
	RETVAL = THIS->program_enable_level;
    OUTPUT:
	RETVAL

boolean
binmode(THIS, __value = NO_INIT)
	kpse_format_info_type * THIS
	boolean __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->binmode = __value;
	RETVAL = THIS->binmode;
    OUTPUT:
	RETVAL

MODULE = Kpse		PACKAGE = kpse_glyph_file_type		

kpse_glyph_file_type *
_to_ptr(THIS)
	kpse_glyph_file_type THIS = NO_INIT
    PROTOTYPE: $
    CODE:
	if (sv_derived_from(ST(0), "kpse_glyph_file_type")) {
	    STRLEN len;
	    char *s = SvPV((SV*)SvRV(ST(0)), len);
	    if (len != sizeof(THIS))
		croak("Size %d of packed data != expected %d",
			len, sizeof(THIS));
	    RETVAL = (kpse_glyph_file_type *)s;
	}   
	else
	    croak("THIS is not of type kpse_glyph_file_type");
    OUTPUT:
	RETVAL

kpse_glyph_file_type
new(CLASS)
	char *CLASS = NO_INIT
    PROTOTYPE: $
    CODE:
	Zero((void*)&RETVAL, sizeof(RETVAL), char);
    OUTPUT:
	RETVAL

MODULE = Kpse		PACKAGE = kpse_glyph_file_typePtr

string
name(THIS, __value = NO_INIT)
	kpse_glyph_file_type * THIS
	string __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->name = __value;
	RETVAL = THIS->name;
    OUTPUT:
	RETVAL

unsigned
dpi(THIS, __value = NO_INIT)
	kpse_glyph_file_type * THIS
	unsigned __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->dpi = __value;
	RETVAL = THIS->dpi;
    OUTPUT:
	RETVAL

kpse_file_format_type
format(THIS, __value = NO_INIT)
	kpse_glyph_file_type * THIS
	kpse_file_format_type __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->format = __value;
	RETVAL = THIS->format;
    OUTPUT:
	RETVAL

kpse_glyph_source_type
source(THIS, __value = NO_INIT)
	kpse_glyph_file_type * THIS
	kpse_glyph_source_type __value
    PROTOTYPE: $;$
    CODE:
	if (items > 1)
	    THIS->source = __value;
	RETVAL = THIS->source;
    OUTPUT:
	RETVAL

